
public class StackUtilities {
	public static void reverse(String[] a) { 
		ArrayedStack buffer = new ArrayedStack(); 
		for (int i = 0; i < a.length; i ++) {
			buffer.push(a[i]);
		}
		for (int i = 0; i < a.length; i ++) {
			a[i] = buffer.pop();
		}
	}

	public static boolean isMatched(String expression) { 
		final String open = "([{"; 
		final String close = ")]}"; 
		ArrayedStack openings = new ArrayedStack(); 
		for (int i = 0; i < expression.length(); i++) { 
			String c = Character.toString(expression.charAt(i)); 
			if(open.indexOf(c) != -1) { openings.push(c); } 
			else if (close.indexOf(c) != -1) { 
				if(openings.isEmpty()) { return false; /* e.g., \{\}) */ }  
				else { 
					if (open.indexOf(openings.top()) == close.indexOf(c)) {
						openings.pop(); } 
					else { return false; /* e.g., (] */ } 
				}
			} 
		}
		return openings.isEmpty(); /* e.g., \{\{ */
	}
}
