public class ArrayedQueue { 
	private static final int MAX_CAPACITY = 1000; 
	private String[] data;
	/* index of rear of queue */
	private int r; 
	
	public ArrayedQueue() { 
		data = new String[MAX_CAPACITY]; 
		r = -1;
	} 
	
	public int size() { 
		return (r + 1); 
	} 
	
	public boolean isEmpty() { 
		return (r == -1); 
	} 
	
	public String first() {
		if (isEmpty()) { 
			throw new IllegalArgumentException("Empty Queue"); 
		} 
		else { 
			return data[0]; 
		} 
	}  
	
	public void enqueue(String e) {
		if (size() == MAX_CAPACITY) { 
			throw new IllegalArgumentException("Full Queue"); 
		}
		else { 
			r ++; data[r] = e; 
		} 
	} 
	
	public String dequeue() {
		String result;
		if (isEmpty()) { throw new IllegalArgumentException("Empty Queue"); } 
		else { 
			result = data[0]; 
			for (int i = 0; i < r; i ++) { 
				data[i] = data[i + 1]; 
			} 
			r --; 
		}
		return result; 
	}
}